import javax.naming.*;
import java.rmi.*;
import java.util.*;
import javax.rmi.PortableRemoteObject;

public class HelloServer extends PortableRemoteObject implements Hello {

	public HelloServer() throws RemoteException
	{
		super();
	}

	public String sayHello(String to)
	{
		System.out.println("Hello-Server called");
		return "Hello World to " + to + "!";
	}

	public static void main(String args[])
	{
		try {
			// Server-Objekt erzeugen
			HelloServer obj = new HelloServer();

			// Referenz beim Namensdienst registrieren
			Properties props = new Properties();
			props.put("java.naming.factory.initial",
					  "com.sun.jndi.cosnaming.CNCtxFactory");
			props.put("java.naming.provider.url",
					  "iiop://localhost:5555");
			Context ctx = new InitialContext(props);
			ctx.rebind("HelloWorld", obj);

			System.out.println("Hello-Server registered");
		}
		catch (Exception e) {
			System.out.println("Error: " + e.getMessage());
			e.printStackTrace();
		}
	}
}
